#Settings
scoreboard players enable @a amm.toggle_double_jump
scoreboard players enable @a amm.toggle_crawling
execute as @a[tag=amm.disableDoubleJump,scores={amm.toggle_double_jump=1..}] run function amm:enable_double_jump
execute as @a[tag=!amm.disableDoubleJump,scores={amm.toggle_double_jump=1..}] run function amm:disable_double_jump

execute as @a[tag=amm.disableCrawling,scores={amm.toggle_crawling=1..}] run function amm:enable_crawling
execute as @a[tag=!amm.disableCrawling,scores={amm.toggle_crawling=1..}] run function amm:disable_crawling


#CRAWLING
execute as @a[scores={amm.canCrawl=0}] at @s unless block ~ ~1 ~1 air if block ~ ~ ~1 air run scoreboard players set @s amm.canCrawl 1
execute as @a[scores={amm.canCrawl=0}] at @s unless block ~ ~1 ~-1 air if block ~ ~ ~-1 air run scoreboard players set @s amm.canCrawl 1
execute as @a[scores={amm.canCrawl=0}] at @s unless block ~1 ~1 ~ air if block ~1 ~ ~ air run scoreboard players set @s amm.canCrawl 1
execute as @a[scores={amm.canCrawl=0}] at @s unless block ~-1 ~1 ~ air if block ~-1 ~ ~ air run scoreboard players set @s amm.canCrawl 1

execute as @a[tag=!amm.disableCrawling,x_rotation=50..90,tag=!amm.crawling,nbt={OnGround:1b},scores={amm.canCrawl=1}] at @s if predicate amm:sneaking unless entity @e[tag=amm.shulker,distance=..3] run function amm:crawl
execute as @a at @s if block ~ ~1 ~ air run tag @s remove amm.crawling

scoreboard players set @a amm.canCrawl 0

execute as @e[tag=amm.shulker] at @s run function amm:entity

#TREE CLIMB
#execute as @a[scores={amm.sneakTime=1..}] at @s positioned ~ ~-0.5 ~ if block ^ ^ ^0.5 #minecraft:logs run effect give @s minecraft:levitation 1 1 true

#scoreboard players add @s shulkertest 1
#DOUBLE JUMP
execute as @a[nbt={OnGround:1b}] at @s positioned ~ ~-0.5 ~ unless entity @e[type=shulker,distance=..3] run tag @s add amm.canDoubleJump
execute as @a[nbt={OnGround:1b}] at @s positioned ~ ~-0.5 ~ if entity @e[type=shulker,distance=..3] run tag @s remove amm.canDoubleJump
execute as @a at @s if block ~ ~ ~ #amm:permeable run tag @s remove amm.canDoubleJump

execute as @a[nbt={OnGround:1b},scores={amm.sneakTime=1..}] run tag @s remove amm.canDoubleJump

execute as @a[tag=amm.canDoubleJump,tag=!amm.disableDoubleJump,nbt={OnGround:0b},scores={amm.sneakTime=1..}] at @s if block ~ ~-0.8 ~ #amm:airs run attribute @s minecraft:safe_fall_distance modifier add amm.safe_add 10 add_value
execute as @a[tag=amm.canDoubleJump,tag=!amm.disableDoubleJump,nbt={OnGround:0b},scores={amm.sneakTime=1..}] at @s if block ~ ~-0.8 ~ #amm:airs run summon area_effect_cloud ~ ~ ~ {Tags:["amm.jumpcloud"],Duration:10}

execute as @e[type=area_effect_cloud,tag=amm.jumpcloud,nbt={Age:0}] at @s run playsound minecraft:entity.horse.saddle master @a
execute as @e[type=area_effect_cloud,tag=amm.jumpcloud,nbt={Age:0}] at @s run particle minecraft:snowflake ~ ~ ~ 0.3 0.1 0.3 0 25
execute as @e[type=area_effect_cloud,tag=amm.jumpcloud,nbt={Age:0}] at @s run summon armor_stand ~ ~-1.5 ~ {Tags:["amm.dstand"],Invulnerable:1b,Marker:1b,Invisible:1b,NoBasePlate:1b,Passengers:[{id:"minecraft:shulker",NoGravity:1b,Silent:1b,Invulnerable:1b,DeathLootTable:"",NoAI:1b,Peek:0b,AttachFace:0b,Tags:["amm.dshulker"],active_effects:[{id:"minecraft:invisibility",amplifier:1b,duration:99999,show_particles:0b}]}]}
execute as @e[type=area_effect_cloud,tag=amm.jumpcloud,nbt={Age:0}] at @s run effect give @a[sort=nearest,distance=..2,limit=1] minecraft:jump_boost 1 1 true 
execute as @e[type=area_effect_cloud,tag=amm.jumpcloud,nbt={Age:0}] at @s run effect give @a[sort=nearest,distance=..2,limit=1] minecraft:jump_boost 1 1 true 

execute as @e[type=area_effect_cloud,tag=amm.jumpcloud,nbt={Age:9}] at @s run kill @e[type=armor_stand,tag=amm.dstand,limit=1,distance=..5]
execute as @e[type=area_effect_cloud,tag=amm.jumpcloud,nbt={Age:9}] at @s run tp @e[type=shulker,tag=amm.dshulker,limit=1,distance=..5] ~ ~-300 ~
execute as @e[type=area_effect_cloud,tag=amm.jumpcloud,nbt={Age:9}] at @s positioned ~ ~-300 ~ run kill @e[type=shulker,tag=amm.dshulker,limit=1,distance=..5]

execute as @a[tag=amm.canDoubleJump,nbt={OnGround:1b}] run attribute @s minecraft:safe_fall_distance modifier remove amm.safe_add
execute as @a[tag=amm.canDoubleJump,nbt={OnGround:0b},scores={amm.sneakTime=1..}] run tag @s remove amm.canDoubleJump



#execute as @a[tag=!amm.canDoubleJump,nbt={OnGround:1b}] at @s unless entity @e[tag=amm.dshulker,sort=nearest,distance=..5] run tag @s add amm.canDoubleJump

#execute as @a[gamemode=!creative,tag=!amm.hasJumped,tag=amm.canDoubleJump,nbt={OnGround:0b},scores={amm.sneakTime=1..}] run tag @s add amm.hasJumped
#execute as @a[tag=amm.hasJumped] run tag @s add amm.initJump

#execute as @a[tag=amm.initJump,nbt={OnGround:0b}] at @s run summon minecraft:area_effect_cloud ~ ~ ~ {Tags:["djump"],Duration:25}

#execute as @a[tag=amm.initJump,nbt={OnGround:0b}] at @s if block ~ ~-1 ~ air run summon shulker ~ ~-1 ~ {NoGravity:1b,Silent:1b,Invulnerable:1b,DeathLootTable:"",NoAI:1b,Peek:0b,AttachFace:0b,Tags:["amm.shulker"],active_effects:[{id:"minecraft:invisibility",amplifier:1b,duration:999999,show_particles:0b}]}

#execute as @a[tag=amm.initJump,nbt={OnGround:0b}] run tag @s remove amm.initJump
#execute as @e[type=minecraft:area_effect_cloud,nbt={Age:0},tag=djump] at @s run playsound minecraft:entity.horse.saddle master @a
#execute as @e[type=minecraft:area_effect_cloud,nbt={Age:0},tag=djump] at @s run particle minecraft:snowflake ~ ~1 ~ 0.3 0.1 0.3 0 25
#execute as @e[type=minecraft:area_effect_cloud,nbt={Age:0},tag=djump] at @s run summon armor_stand ~ ~-1.5 ~ {Tags:["amm.dstand"],Invulnerable:1b,Marker:1b,Invisible:1b,NoBasePlate:1b,Passengers:[{id:"minecraft:shulker",NoGravity:1b,Silent:1b,Invulnerable:1b,DeathLootTable:"",NoAI:1b,Peek:0b,AttachFace:0b,Tags:["amm.dshulker"],active_effects:[{id:"minecraft:invisibility",amplifier:1b,duration:99999,show_particles:0b}]}]}
#shulker ~ ~-1 ~ {NoGravity:1b,Silent:1b,Invulnerable:1b,DeathLootTable:"",NoAI:1b,Peek:0b,AttachFace:0b,Tags:["amm.dshulker"],active_effects:[{id:"minecraft:invisibility",amplifier:1b,duration:999999,show_particles:0b}]}
#execute as @e[type=minecraft:area_effect_cloud,nbt={Age:8},tag=djump] at @s run kill @e[tag=amm.dstand,sort=nearest,limit=1]
#execute as @e[type=minecraft:area_effect_cloud,nbt={Age:8},tag=djump] at @s run tp @e[tag=amm.dshulker,sort=nearest,limit=1] ~ ~-300 ~


#execute as @a[tag=amm.hasJumped] at @s if entity @e[tag=amm.dshulker,sort=nearest,distance=..5] run effect give @s minecraft:jump_boost 1 0 true 
#execute as @a[tag=amm.hasJumped] run tag @s remove amm.canDoubleJump
#execute as @a[tag=amm.hasJumped] run tag @s remove amm.hasJumped

execute as @a[scores={amm.sneakTime=1..}] run scoreboard players set @s amm.sneakTime 0

schedule function amm:loops/main 1t
